package kubernetes

# Test for invalid Kubernetes containers[_].resources.requests configured for CPU & Memory
test_resource_missing_container_resources_requests_invalid {
    i := data.mock.bad_job
    r1 := warn_resource_missing_container_resources_requests with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_missing_container_resources_requests with input as i with data.config.warn_mode as ["resource_missing_container_resources_requests"]
    count(r2) == 2
    r3 := deny_resource_missing_container_resources_requests with input as i with data.config.warn_mode as []
    count(r3) == 2
    r4 := deny_resource_missing_container_resources_requests with input as i with data.config.warn_mode as ["resource_missing_container_resources_requests"]
    count(r4) == 0
    count(r1) + count(r2) == 2 # Warning mode is off
    count(r3) + count(r4) == 2 # Warning mode is on
}

# Test for valid Kubernetes containers[_].resources.requests configured for CPU & Memory
test_resource_missing_container_resources_requests_valid {
    i := data.mock.good_job
    r1 := warn_resource_missing_container_resources_requests with input as i with data.config.warn_mode as []
    r2 := warn_resource_missing_container_resources_requests with input as i with data.config.warn_mode as ["resource_missing_container_resources_requests"]
    r3 := deny_resource_missing_container_resources_requests with input as i with data.config.warn_mode as []
    r4 := deny_resource_missing_container_resources_requests with input as i with data.config.warn_mode as ["resource_missing_container_resources_requests"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid Kubernetes containers[_].resources.limits configured for CPU & Memory
test_resource_missing_container_resources_limits_invalid {
    i := data.mock.bad_job
    r1 := warn_resource_missing_container_resources_limits with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_missing_container_resources_limits with input as i with data.config.warn_mode as ["resource_missing_container_resources_limits"]
    count(r2) == 2
    r3 := deny_resource_missing_container_resources_limits with input as i with data.config.warn_mode as []
    count(r3) == 2
    r4 := deny_resource_missing_container_resources_limits with input as i with data.config.warn_mode as ["resource_missing_container_resources_limits"]
    count(r4) == 0
    count(r1) + count(r2) == 2 # Warning mode is off
    count(r3) + count(r4) == 2 # Warning mode is on
}

# Test for valid Kubernetes containers[_].resources.limits configured for CPU & Memory
test_resource_missing_container_resources_limits_valid {
    i := data.mock.good_job
    r1 := warn_resource_missing_container_resources_limits with input as i with data.config.warn_mode as []
    r2 := warn_resource_missing_container_resources_limits with input as i with data.config.warn_mode as ["resource_missing_container_resources_limits"]
    r3 := deny_resource_missing_container_resources_limits with input as i with data.config.warn_mode as []
    r4 := deny_resource_missing_container_resources_limits with input as i with data.config.warn_mode as ["resource_missing_container_resources_limits"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}