package kubernetes

# Test for invalid Kubernetes readiness probes
test_deployment_missing_readiness_probe_invalid {
    i := data.mock.bad_deployment
    r1 := warn_deployment_missing_readiness_probe with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_deployment_missing_readiness_probe with input as i with data.config.warn_mode as ["deployment_missing_readiness_probe"]
    count(r2) == 1
    r3 := deny_deployment_missing_readiness_probe with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_pod_missing_readiness_probe with input as i with data.config.warn_mode as ["deployment_missing_readiness_probe"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes readiness probes
test_deployment_missing_readiness_probe_valid {
    i := data.mock.good_deployment
    r1 := warn_deployment_missing_readiness_probe with input as i with data.config.warn_mode as []
    r2 := warn_deployment_missing_readiness_probe with input as i with data.config.warn_mode as ["deployment_missing_readiness_probe"]
    r3 := deny_deployment_missing_readiness_probe with input as i with data.config.warn_mode as []
    r4 := deny_deployment_missing_readiness_probe with input as i with data.config.warn_mode as ["deployment_missing_readiness_probe"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid Kubernetes liveness probes
test_deployment_missing_liveness_probe_invalid {
    i := data.mock.bad_deployment
    r1 := warn_deployment_missing_readiness_probe with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_deployment_missing_readiness_probe with input as i with data.config.warn_mode as ["deployment_missing_readiness_probe"]
    count(r2) == 1
    r3 := deny_deployment_missing_readiness_probe with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_deployment_missing_readiness_probe with input as i with data.config.warn_mode as ["deployment_missing_readiness_probe"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes liveness probes
test_deployment_missing_liveness_probe_valid {
    i := data.mock.good_deployment
    r1 := warn_deployment_missing_liveness_probe with input as i with data.config.warn_mode as []
    r2 := warn_deployment_missing_liveness_probe with input as i with data.config.warn_mode as ["deployment_missing_liveness_probe"]
    r3 := deny_deployment_missing_liveness_probe with input as i with data.config.warn_mode as []
    r4 := deny_deployment_missing_liveness_probe with input as i with data.config.warn_mode as ["deployment_missing_liveness_probe"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid Kubernetes imagePullPolicy
test_deployment_image_pull_policy_invalid {
    i := data.mock.bad_deployment
    r1 := warn_deployment_image_pull_policy with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_deployment_image_pull_policy with input as i with data.config.warn_mode as ["deployment_image_pull_policy"]
    count(r2) == 1
    r3 := deny_deployment_image_pull_policy with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_deployment_image_pull_policy with input as i with data.config.warn_mode as ["deployment_image_pull_policy"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes imagePullPolicy
test_deployment_image_pull_policy_valid {
    i := data.mock.good_deployment
    r1 := warn_deployment_image_pull_policy with input as i with data.config.warn_mode as []
    r2 := warn_deployment_image_pull_policy with input as i with data.config.warn_mode as ["deployment_image_pull_policy"]
    r3 := deny_deployment_image_pull_policy with input as i with data.config.warn_mode as []
    r4 := deny_deployment_image_pull_policy with input as i with data.config.warn_mode as ["deployment_image_pull_policy"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid Kubernetes priviliged security context
test_deployment_security_context_privileged_invalid {
    i := data.mock.bad_deployment
    r1 := warn_deployment_security_context_privileged with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_deployment_security_context_privileged with input as i with data.config.warn_mode as ["deployment_security_context_privileged"]
    count(r2) == 2
    r3 := deny_deployment_security_context_privileged with input as i with data.config.warn_mode as []
    count(r3) == 2
    r4 := deny_deployment_security_context_privileged with input as i with data.config.warn_mode as ["deployment_security_context_privileged"]
    count(r4) == 0
    count(r1) + count(r2) == 2 # Warning mode is off
    count(r3) + count(r4) == 2 # Warning mode is on
}

# Test for valid Kubernetes priviliged security context
test_deployment_security_context_privileged_valid {
    i := data.mock.good_deployment
    r1 := warn_deployment_security_context_privileged with input as i with data.config.warn_mode as []
    r2 := warn_deployment_security_context_privileged with input as i with data.config.warn_mode as ["deployment_security_context_privileged"]
    r3 := deny_deployment_security_context_privileged with input as i with data.config.warn_mode as []
    r4 := deny_deployment_security_context_privileged with input as i with data.config.warn_mode as ["deployment_security_context_privileged"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}