package kubernetes

# Test for invalid Kubernetes imagePullPolicy
test_job_image_pull_policy_invalid {
    i := data.mock.bad_job
    r1 := warn_job_image_pull_policy with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_job_image_pull_policy with input as i with data.config.warn_mode as ["job_image_pull_policy"]
    count(r2) == 1
    r3 := deny_job_image_pull_policy with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_job_image_pull_policy with input as i with data.config.warn_mode as ["job_image_pull_policy"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes imagePullPolicy
test_job_image_pull_policy_valid {
    i := data.mock.good_job
    r1 := warn_job_image_pull_policy with input as i with data.config.warn_mode as []
    r2 := warn_job_image_pull_policy with input as i with data.config.warn_mode as ["job_image_pull_policy"]
    r3 := deny_job_image_pull_policy with input as i with data.config.warn_mode as []
    r4 := deny_job_image_pull_policy with input as i with data.config.warn_mode as ["job_image_pull_policy"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid job security context
test_job_security_context_privileged_invalid {
    i := data.mock.bad_job
    r1 := warn_job_security_context_privileged with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_job_security_context_privileged with input as i with data.config.warn_mode as ["job_security_context_privileged"]
    count(r2) == 1
    r3 := deny_job_security_context_privileged with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_job_security_context_privileged with input as i with data.config.warn_mode as ["job_security_context_privileged"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid job security context
test_job_security_context_privileged_valid {
    i := data.mock.good_job
    r1 := warn_job_security_context_privileged with input as i with data.config.warn_mode as []
    r2 := warn_job_security_context_privileged with input as i with data.config.warn_mode as ["job_security_context_privileged"]
    r3 := deny_job_security_context_privileged with input as i with data.config.warn_mode as []
    r4 := deny_job_security_context_privileged with input as i with data.config.warn_mode as ["job_security_context_privileged"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}